/*

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

    Copyright (C) 2006 by Clemens Helfmeier,
    Clemens(at)Helfmeier[dot]de

*/

#include "debug.h"
#define DBG_LEVEL   DBG_LEVEL_VERBOSE
#include "debug.h"


#include "net/net.h"
#include "net/netconfig.h"
#include "net/proto/udp.h"
#include "net/proto/tcp.h"
#include "system/time.h"

#include "utils/reorder.h"

#include "memory/mem.h"


void app_main( void ) {

    reorder_init();
    
    udp_socket s;
    udp_listen( &s, 0,0, 9936,9936 );
    
    unsigned int t = time_getTickCount();
    while(1) {
        void * mem;
        unsigned int len;
        if (reorder_count() > 5) {
            if (reorder_read( &mem, &len ) == ERROR_SUCCESS)  {
                DBG_V_S( "next packet: " ); DBG_V_I( *((int*)(mem+UDP_OFFSET+2))); DBG_V_S( ".\n" );
                mem_free( mem );
            }
        }
        if (udp_recv( &s, &mem, &len ) == ERROR_SUCCESS) {
            unsigned int i = *((int*)(mem+UDP_OFFSET+2));
            if (reorder_put( mem, len, i ) != ERROR_SUCCESS) {
                DBG_V_S( "could not put " ); DBG_V_I( i ); DBG_V_S( ".\n" );
                mem_free( mem );
            } else {
                DBG_V_S( "put packet: " ); DBG_V_I( i ); DBG_V_S( ".\n" );
            }
        }
        if (t < time_getTickCount()) {
            // there seems to be a memory problem, still. debugging every second.
            mem_debug();
            t = time_getTickCount() + 1000000;
        }
        net_input();
    }
}


