/*

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

    Copyright (C) 2006 by Clemens Helfmeier,
    Clemens(at)Helfmeier[dot]de

*/


#include "debug/debug.h"
#define DBG_LEVEL   DBG_LEVEL_ERROR
#include "debug/debug.h"

/** this is called after an DATA ABORT exception.
 * it is executed in System mode, zero is not used yet.
 * return the new return address
 */
void * data_abort_handler( void * src_address, void * stack, int zero ) {
    DBG_C_S( "DATA ABORT OCCURED! -------------------\n" );
    DBG_C_S( " src_address: " ); DBG_C_I( src_address ); DBG_C_S( "\n" );
    DBG_C_S( " stack:       " ); DBG_C_I( stack ); DBG_C_S( "\n" );
    DBG_C_S( " zero:        " ); DBG_C_I( zero ); DBG_C_S( "\n" );
    for (unsigned int i = 0; i<50; i++) delay_ms( 100 );
    DBG_C_S( "DATA ABORT RETURNING! -----------------\n" );
    return src_address + 4;
}

/** this is called after an PREFETCH ABORT exception.
 * it is executed in System mode, zero is not used yet.
 * return the new return address
 */
void * prefetch_abort_handler( void * src_address, void * stack, int zero ) {
    DBG_C_S( "PREFETCH ABORT OCCURED! -------------------\n" );
    DBG_C_S( " src_address: " ); DBG_C_I( src_address ); DBG_C_S( "\n" );
    DBG_C_S( " stack:       " ); DBG_C_I( stack ); DBG_C_S( "\n" );
    DBG_C_S( " zero:        " ); DBG_C_I( zero ); DBG_C_S( "\n" );
    for (unsigned int i = 0; i<50; i++) delay_ms( 100 );
    DBG_C_S( "PREFETCH ABORT RETURNING! -----------------\n" );
    return src_address;
}

