/*

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

    Copyright (C) 2006 by Clemens Helfmeier,
    Clemens(at)Helfmeier[dot]de

*/


#ifndef _I2S_H_
#define _I2S_H_

#include "system/error.h"

#ifdef __cplusplus
extern "C" {
#endif


void i2s_init( void );
void i2s_powerdown( void );

void i2s_t( int data );
int i2s_r( void );

ERROR i2s_addRxBuffer( void * buf, unsigned int len );
ERROR i2s_addTxBuffer( void * buf, unsigned int len );

void i2s_setRxFullHandler( void (*handler)( void ) );
void i2s_setTxEmptyHandler( void (*handler)( void ) );

unsigned int i2s_RxEmptyBufferCount( void );
unsigned int i2s_TxEmptyBufferCount( void );

void i2s_enableInterrupt( void );
void i2s_disableInterrupt( void );

#ifdef __cplusplus
}
#endif

#endif
