
/*

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

    Copyright (C) 2006 by Clemens Helfmeier,
    Clemens(at)Helfmeier[dot]de

*/

#include "led.h"

#include "AT91SAM7S64.h"
#define __inline extern inline
#include "lib_AT91SAM7S64.h"


void led_init( void ) {
	AT91F_PIO_CfgOutput( AT91C_BASE_PIOA, (LED_RED | LED_GREEN | LED_YELLOW) );
	led_off( LED_RED | LED_GREEN | LED_YELLOW );
}

void led_on( int led ) {
	AT91F_PIO_ClearOutput( AT91C_BASE_PIOA, (led & (LED_RED | LED_GREEN | LED_YELLOW)) );
}
void led_off( int led ) {
	AT91F_PIO_SetOutput( AT91C_BASE_PIOA, (led & (LED_RED | LED_GREEN | LED_YELLOW)) );
}
void led_swap( int led ) {
	AT91F_PIO_SetOutput( AT91C_BASE_PIOA, ~(AT91F_PIO_GetOutputDataStatus( AT91C_BASE_PIOA )) & (led & (LED_RED | LED_GREEN | LED_YELLOW)) );
	AT91F_PIO_ClearOutput( AT91C_BASE_PIOA, (AT91F_PIO_GetOutputDataStatus( AT91C_BASE_PIOA )) & (led & (LED_RED | LED_GREEN | LED_YELLOW)) );
}
