/*

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

    Copyright (C) 2006 by Clemens Helfmeier,
    Clemens(at)Helfmeier[dot]de

*/
/*
 * Startup Code for ARM
 *
 * Configuration for the startup code.
 * (more details below)
 *
 * by: Clemens Helfmeier
 * ClemensHelfmeier {at] gmx `dot" de
 * (replace the corresponding at and dot in the email, please).
 */

#ifndef _STARTUP_CONFIG_H_
#define _STARTUP_CONFIG_H_
/* include the ARM-Modes here, they are needed for MAIN_MODE */
#include "arm.inc"

/* If you want the main() routine and all the other C-Stuff (Interrupts,...) to run
 * in *User* Mode, set this define to "ARM_MODE_User". If you want it to run in *System*
 * Mode, set it to "ARM_MODE_System".
 * For very small Devices (like AT91SAM7S), it doesn't make sense to not run the program
 * in System Mode.
 * Using ARM_MODE_System here saves the SWI-Handler (about 144Byte).
 */
#define MAIN_MODE	ARM_MODE_System

/* if you want to support the SWI-Instruction (like OS-Calls from dynamically linked Code),
 * set this define to 1.
 */
#define FORCE_INCLUDE_SWI	0

/* if your code exits, it could be important to call global destructors. Set this define
 * to 1 for execute (and include) destructors.
 */
#define DESTRUCTORS		0

#if ((defined(FORCE_INCLUDE_SWI) && (FORCE_INCLUDE_SWI == 1)) || (MAIN_MODE == ARM_MODE_User))
	#define ENABLE_SWI	1
#else
	#define ENABLE_SWI	0
#endif


#endif
