/*

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

    Copyright (C) 2006 by Clemens Helfmeier,
    Clemens(at)Helfmeier[dot]de

*/
/*
 * Startup Code for ARM
 *
 * C-Handler for SWI
 * a SWI should be executed if the program want's to reach a previliged mode
 * the Handler then can do the requested action.
 *
 * by: Clemens Helfmeier
 * ClemensHelfmeier {at] gmx `dot" de
 * (replace the corresponding at and dot in the email, please).
 */


#include "swi_c.h"
#include "startup_config.h"

#if (ENABLE_SWI == 1)
/* only compile the SWI if it is enabled. */

unsigned int spurious_swi = 0;

void SWI_CHandler( unsigned int swi_code ) {
	/* this procedure handles the SWI in C
	 * swi_code ist the number that was called.
	 * this procedure is always executed in SYSTEM mode
	 * be careful what to do here.
	 */
	switch( swi_code ) {
		default:
			/* spurious software interrupt */
			spurious_swi++;
			break;
	}
}


#endif
