/*

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

    Copyright (C) 2006 by Clemens Helfmeier,
    Clemens(at)Helfmeier[dot]de

*/




#include "usart.h"
#include "startup_sam7.h"

#include "AT91SAM7S64.h"
#define __inline extern inline
#include "lib_AT91SAM7S64.h"



void usart_init() {

	AT91F_US0_CfgPMC();
//	AT91F_US0_CfgPIO();
	AT91F_PIO_CfgPeriph( AT91C_BASE_PIOA, AT91C_PA6_TXD0, 0 );
	/* we need only TXD0 */

	AT91C_BASE_US0->US_CR = AT91C_US_RSTRX | AT91C_US_RSTTX | AT91C_US_RXDIS | AT91C_US_TXDIS;
	AT91F_US_SetBaudrate( AT91C_BASE_US0, F_CPU, 115200 );
	AT91C_BASE_US0->US_MR = AT91C_US_USMODE_NORMAL | AT91C_US_CLKS_CLOCK | AT91C_US_CHRL_8_BITS | AT91C_US_PAR_NONE | AT91C_US_NBSTOP_1_BIT | AT91C_US_CHMODE_NORMAL;
	AT91F_US_EnableTx( AT91C_BASE_US0 );
	
}

inline void usart_putc( char c ) {
	while ((AT91C_BASE_US0->US_CSR & AT91C_US_TXRDY) == 0);
	AT91C_BASE_US0->US_THR = c;
}
void usart_puts( char *c ) {
    /*
#ifdef USE_DMA
	unsigned int len = 0;
	while (*(c+len)!=0) len++;
	if (len > 0) {
		while (AT91F_PDC_SendFrame( AT91C_BASE_PDC_US0, c, len, 0, 0 ) == 0);
	}
#else
    */
	if (c == 0) return;
	while (*c!=0)
		usart_putc( *c++ );
//#endif
}

