#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>

#include <sys/ioctl.h>
#include <unistd.h>
#include <fcntl.h>

#define BUFLEN 1024
#define PORT 9936

void diep(char *s)
{
    perror(s);
    exit(1);
}



int main(unsigned int argc, char *argv[])
{
    struct sockaddr_in *sock_server;
    int s, i;
    socklen_t socklen = sizeof(struct sockaddr_in);
    char buf[BUFLEN];
    int fd;
    
    sock_server = (struct sockaddr_in *) malloc( socklen );

    if ( !sock_server )
        diep( "allocation failed" );

    if ((s = socket(PF_INET, SOCK_DGRAM, IPPROTO_UDP)) == -1)
        diep("socket");

    sock_server->sin_family = AF_INET;
    sock_server->sin_port = htons(PORT);

    if (inet_aton("192.168.6.20", &(sock_server->sin_addr)) == 0) {

        fprintf(stderr, "inet_aton() failed\n");
        exit(1);

    }

    if (argc != 2) {
        printf( "invalid number of arguments: %i\n", argc );
        exit(1);
    }
    if ((fd = open( argv[1], O_RDONLY, 0)) == -1) { /* Opening device failed */ 
        perror(argv[1]); 
        exit(1); 
    }
    
    while (1) {
        int len = read( fd, buf, BUFLEN );
        if (len < 0) 
            diep("read");
        if (len != 0) {
            if (sendto(s, buf, len, 0, (struct sockaddr*) sock_server, socklen) == -1)
                diep("sendto()");
        }
        
        printf(" %i bytes sent.\n", len);
        usleep(38000);
    }

    close(s);
    return 0;
}

