/*

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

    Copyright (C) 2006 by Clemens Helfmeier,
    Clemens(at)Helfmeier[dot]de

*/



#ifndef _ETHERNET_H_
#define _ETHERNET_H_

#include "system/error.h"

#ifdef __cplusplus
extern "C" {
#endif


/** Ethernet addresses consist of six chars.
 */
typedef struct __attribute__ ((__packed__)) {
     char addr[6];
} ethernet_address;

typedef unsigned short ethernet_protocol;

    /** Ethernet header type.
 */
typedef struct __attribute__ ((__packed__)) {
    ethernet_address dest;
    ethernet_address src;
    ethernet_protocol proto;
} ethernet_header;

/** initialization */
ERROR ethernet_init( void );
/** packet output */
ERROR ethernet_send_packet( void * mem, unsigned int len, ethernet_address * dst, ethernet_protocol proto );
/** packet input */
/* dependancy problem araise when this is defined here since the macros are not yet defined...
void inline ethernet_input_handler( char * data, unsigned int len ) {
    ethernet_header * ehdr = (ethernet_header*)(data + ETHERNET_OFFSET - ETHERNET_HEADER_SIZE);
    if (ehdr->proto == ETHERNET_PID_IPV4) {
        IPV4_INPUT_HANDLER( data, len );
    } else if (ehdr->proto == ETHERNET_PID_ARP) {
        ARP_INPUT_HANDLER( data, len );
    }
}
*/



#ifdef __cplusplus
}
#endif
#endif

