/*

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

    Copyright (C) 2006 by Clemens Helfmeier,
    Clemens(at)Helfmeier[dot]de

*/



#ifndef _ENC28j60_H_
#define _ENC28j60_H_

#include "system/error.h"


#ifdef __cplusplus
extern "C" {
#endif


    /** initialize everything of the enc28j60 */
ERROR enc28j60_init( void );

    /** send the packet at mem with length len and free the buffer with mem_free( mem ); */
ERROR enc28j60_send_packet( void * mem, unsigned int len );

    /** power down the interface, disable reception of packets */
ERROR enc28j60_power_down( void );

    /** handle incoming packets */
void enc28j60_receive_packets( void );

unsigned int enc28j60_txfifo_fill( void );
unsigned int enc28j60_rxfifo_fill( void );


#ifdef __cplusplus
}
#endif
#endif
