/*

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

    Copyright (C) 2006 by Clemens Helfmeier,
    Clemens(at)Helfmeier[dot]de

*/



#ifndef _IPV4_H_
#define _IPV4_H_


#include <stdint.h>

#include "system/error.h"

#ifdef __cplusplus
extern "C" {
#endif

/** The IPV4 protocol address consits of four characters.
 */
/*
typedef struct __attribute__ ((__packed__)) {
    uint8_t addr[4];	///< IPV4 Address
} ipv4_address;
*/
typedef uint32_t ipv4_address;
#define A2IPV4( a,b,c,d )         ((ipv4_address)((a<<24)|(b<<16)|(c<<8)|d))
//#define A2IPV4( x )                 ((uint32_t)(char[])x)
    
typedef uint8_t ipv4_protocol;


typedef struct __attribute__ ((__packed__)) {
    uint8_t          ihl:4,
                     version:4;
    uint8_t          tos;
    uint16_t         tot_len;
    uint16_t         id;
    uint16_t         frag_off;
    uint8_t          ttl;
    uint8_t          protocol;
    uint16_t         check;
    ipv4_address saddr;
    ipv4_address daddr; 
    /*The options start here. */
} ipv4_header;

#define FRAGMENT_OFFSET             (0x1FFF)
#define FRAGMENT_MOREFRAGMENTS      (0x2000)
#define FRAGMENT_DONTFRAGMENT       (0x4000)
#define FRAGMENT_CONGESTION         (0x8000)


/** prototypes
 */
ERROR ipv4_init( void );

ERROR ipv4_send_packet( void * mem, unsigned int len, ipv4_address dst, ipv4_protocol proto );

void ipv4_input_handler( void * mem, unsigned int len );


#ifdef __cplusplus
}
#endif


#endif
