/*

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

    Copyright (C) 2006 by Clemens Helfmeier,
    Clemens(at)Helfmeier[dot]de

*/



#include "net/userconfig.h"
#include "net/mac/enc28j60.h"
#include "net/dll/ethernet.h"
#include "net/net/ipv4.h"
#include "net/proto/udp.h"
#include "net/proto/tcp.h"
#include "net/proto/icmp.h"
#include "net/proto/arp.h"

const ethernet_address this_ethernet_address = {0x5c,0x00,0x10,0x51,0x45,0xb9};
const ipv4_address this_ipv4_address = A2IPV4(192,168,6,20);
const ipv4_address this_ipv4_subnet = A2IPV4(192,168,6,0);
const ipv4_address this_ipv4_mask = A2IPV4(255,255,255,0);
const ipv4_address this_ipv4_gateway = A2IPV4(192,168,6,11);
const ethernet_address ethernet_broadcast_address = { 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF };



/** initialize all parts of the network
 */
ERROR net_init( void ) {

    ERROR ret;
    ret = enc28j60_init(); if (ret != ERROR_SUCCESS) return ret;
    ret = ethernet_init(); if (ret != ERROR_SUCCESS) return ret;
    ret = arp_init(); if (ret != ERROR_SUCCESS) return ret;
    ret = ipv4_init(); if (ret != ERROR_SUCCESS) return ret;
    ret = udp_init(); if (ret != ERROR_SUCCESS) return ret;
//    ret = tcp_init(); if (ret != ERROR_SUCCESS) return ret;
    ret = icmp_init(); if (ret != ERROR_SUCCESS) return ret;

    return ERROR_SUCCESS;
}

void net_input( void ) {
    enc28j60_receive_packets();
}

