/*

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

    Copyright (C) 2006 by Clemens Helfmeier,
    Clemens(at)Helfmeier[dot]de

*/


#ifndef _ICMP_H_
#define _ICMP_H_

#include <stdint.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef struct __attribute__ ((__packed__)) {
    uint8_t type;
    uint8_t code;
    uint16_t crc;
    uint16_t identifier;
    uint16_t seqnr;
} icmp_header;




ERROR icmp_init( void );

void icmp_input_handler( void * mem, unsigned int len );



/// ICMP CODE FIELD
//destination unreachable
#define ICMP_DSTUNR_NET         0x00
#define ICMP_DSTUNR_HOST        0x01
#define ICMP_DSTUNR_PROTO       0x02
#define ICMP_DSTUNR_PORT        0x03
#define ICMP_DSTUNR_FRAG        0x04
#define ICMP_DSTUNR_SRCROUTE    0x05
ERROR icmp_dstunr( void * mem, unsigned int len, uint8_t code );

#ifdef __cplusplus
}
#endif
#endif

