/*

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

    Copyright (C) 2006 by Clemens Helfmeier,
    Clemens(at)Helfmeier[dot]de

*/

#ifndef _ERROR_H_
#define _ERROR_H_

typedef enum {
	ERROR_SUCCESS = 0x00,
    
    ERROR_OUT_OF_MEMORY = 0x01,
    
    ERROR_LINK_DOWN = 0x102,
    ERROR_ARP_NOT_IN_CACHE = 0x103,
    ERROR_ARP_NOT_QUERYING = 0x104,
    
    ERROR_UDP_EMPTY = 0x201,
    ERROR_UDP_NO_CACHE = 0x202,
    
    ERROR_DNS_INVALID_NAME = 0x301,
    ERROR_DNS_NOT_IN_CACHE = 0x303,
    ERROR_DNS_NOT_QUERYING = 0x304,
    
    ERROR_TCP_NO_CACHE = 0x402,
    ERROR_TCP_INVALID_STATE = 0x410,
    
    ERROR_FAILURE = 0x1000,
    
    ERROR_NOT_IMPLEMENTED = 0x1001,
    
} ERROR;






#endif
