/*

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

    Copyright (C) 2006 by Clemens Helfmeier,
    Clemens(at)Helfmeier[dot]de

*/

/** @file system.c
 * @brief This file includes functions and variables that do not fit in any other file or that are not
 * categorized yet.
 *
 * @author Clemens Helfmeier
 * @date 25.06.06
 */


#include "AT91SAM7S64.h"
#define __inline extern inline
#include "lib_AT91SAM7S64.h"

#include "system.h"

#include "startup_sam7.h"

/// Debugging support
#include "debug.h"
#define DBG_LEVEL	DBG_LEVEL_ERROR
#include "debug.h"



/* active waiting. these functions must not change the task! */
void delay_ms( unsigned int ms ) {
	for (unsigned int i = 0; i<(48000000/(12*1000))*ms; i++) __asm__ volatile ("nop");
}

void delay_us( unsigned int us ) {
	for (unsigned int i = 0; i<(48000000/(12*1000000))*us; i++) __asm__ volatile ("nop");
}

void system_init( void ) {

}

unsigned short random16( void ) {
	/* return a pseudo random number (16 Bit) */
	return (AT91C_BASE_PITC->PITC_PIIR & 0xFFFF);
}

char * itoa( unsigned int i, char * s, unsigned int r ) {
    // convert the number i to the string s with radix r
    if (r > 16) {
        *s = 0;
        return s;
    }
    static const char base[] = "0123456789ABCDEF";
    unsigned int len = 0;
    char * str = s;
    char * str_save = s;
    while (i > 0) {
        *s++ = base[ i % r ];
        i = i / r;
        len++;
    }
    // add zero-character
    *s = 0;
    // turn around the whole string
    for (len = len >> 1; len > 0; len--) {
        char tmp = *str;
        *str++ = *--s;
        *s = tmp;
    }
    return str_save;
}
