/*

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

    Copyright (C) 2006 by Clemens Helfmeier,
    Clemens(at)Helfmeier[dot]de

*/


#ifndef _SYSTEM_H_
#define _SYSTEM_H_

#ifdef __cplusplus
extern "C" {
#endif

void delay_ms( unsigned int ms );
void delay_us( unsigned int us );


void system_init( void );

unsigned short random16( void );

char * itoa( unsigned int i, char * s, unsigned int r );
/** read addr and write write_value to addr without interruption
 */
static inline unsigned int arm_swap( unsigned int write_value, unsigned int * addr ) {
    unsigned int ret;
    __asm__ volatile (
        "swp %0, %1, [%2]\n\t"
        : "=r" (ret)
        : "r" (write_value), "r" (addr)
        : "memory"
                     );
    return ret;
}

#ifdef __cplusplus
}
#endif

#endif
