/*

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

    Copyright (C) 2006 by Clemens Helfmeier,
    Clemens(at)Helfmeier[dot]de

*/

#include "system/time.h"

#include "controller/startup_sam7.h"

#include "AT91SAM7S64.h"
#define __inline extern inline
#include "lib_AT91SAM7S64.h"


void time_init( void ) {
    AT91C_BASE_PITC->PITC_PIMR = AT91C_SYSC_PITEN | AT91C_SYSC_PITIEN | (-1 & AT91C_SYSC_PIV);
    /* clear timer by reading the PIVR */
    { volatile unsigned int i = AT91C_BASE_PITC->PITC_PIVR; }
}


/** Return the value of the TickCounter. The tick counter is incremented each 1us.
 */
unsigned int time_getTickCount( void ) {
    return AT91C_BASE_PITC->PITC_PIIR/(F_CPU/16.0/1000000.0);
}



