/*

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

    Copyright (C) 2006 by Clemens Helfmeier,
    Clemens(at)Helfmeier[dot]de

*/



#ifndef _SYNCHRONIZATION_H_
#define _SYNCHRONIZATION_H_

// synchronization is achieved by disabling the interrupts
#include "controller/interrupt.h"

// the old interrupt status is saved in the syncobject
#define SYNC_OBJECT( syncobj )  unsigned int syncobj

#define SYNC( syncobj )     {syncobj = DISABLE_ALL_INTERRUPTS();}
#define DESYNC( syncobj )   {ENABLE_ALL_INTERRUPTS( syncobj );}













#endif
